/*******************************************************************************
* Copyright (C) 2017 CEESAR, FITT, INRIA, UCBL-Ifsttar                         *
* This file is part of the PIPER Framework.                                    *
* Version: 1.0.0                                                               *
*                                                                              *
* The PIPER Framework is free software: you can redistribute it and/or modify  *
* it under the terms of the GNU General Public License as published by the     *
* Free Software Foundation, either version 2 of the License, or (at your       *
* option) any later version.                                                   *
*                                                                              *
* The PIPER Framework is distributed in the hope that it will be useful, but   *
* WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY   *
* or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License     *
* for more details. You should have received a copy of the GNU General Public  *
* License along with the PIPER Framework.                                      *
* If not, see <http://www.gnu.org/licenses/>.                                  *
*                                                                              *
* Contributors include Erwan Jolivet (CEESAR); Aditya Chhabra, Sachiv          *
* Paruchuri, Dhruv Kaushik, Sukhraj Singh, Kshitij Mishra, Anoop Chawla        *
* (FITT); Thomas Lemaire (INRIA); Tomas Janak, Thomas Dupeux, Matthieu Mear    *
* (UCBL-Ifsttar)                                                               *
*                                                                              *
* This work has received funding from the European Union Seventh Framework     *
* Program ([FP7/2007-2013]) under grant agreement 605544 [PIPER project]).     *
*                                                                              *
*******************************************************************************/
#ifndef PIPER_HBM_VTKFEMODEL_H
#define PIPER_HBM_VTKFEMODEL_H

#ifdef WIN32
#	ifdef hbm_EXPORTS
#		define HBM_EXPORT __declspec( dllexport )
#	else
#		define HBM_EXPORT __declspec( dllimport )
#	endif
#else
#	define HBM_EXPORT
#endif

#pragma warning(disable:4503) // "decorated name length exceeded" generated by boost templates
#include <boost/container/map.hpp>
#include <boost/container/vector.hpp>
#include "Metadata.h"
#include <vtkUnstructuredGrid.h>
#include <vtkSmartPointer.h>
#include <vtkPolyData.h>


// the name of the scalar array that contains the computed element quality
#define QUALITY_SCALAR_ARRAY "Quality"
// the name of the scalar bit array that contains 1 for landmark points that should be visualized and 0 for the rest
#define ACTIVE_LANDMARK_POINTS "ActiveLandmarks"


namespace piper 
{
    // an enum for the differents metric function a user can chose for quality coloration
    enum class METRIC_FUNCTION { ASPECT_FROBENIUS = 0, MIN_ANGLE, MAX_ANGLE, CONDITION, SCALED_JACOBIAN, 
        RELATIVE_SIZE_SQUARED, SHAPE, SHAPE_AND_SIZE, DISTORTION, AREA, EDGE_RATIO, ASPECT_RATIO, RADIUS_RATIO, VOLUME, 
    };

    static const std::array<std::string, 14> QualityMetrics_str = {
            { "Aspect Frobenius", "Min Angle", "Max Angle", "Condition", "Scaled Jacobian", 
            "Relative size squared", "Shape", "Shape and Size", "Distortion", "Area", "Edge Ratio",
            "Aspect Ratio", "Radius Ratio", "Volume"}
    };

    inline bool operator==(unsigned int a, METRIC_FUNCTION b)
    {
        return static_cast<int>(a) == static_cast<int>(b);
    }

    namespace hbm 
    {
		class HBM_EXPORT FEModel;

		/**
		* @brief A class to store a vtk representation of the Finite Element Model's geometry.
		* It is intended for fast processing of purely geometrical querries on the model,
		* it mimics (only) the necessarry functionality of hbm::FEModel class for such querries.
		* 
		*
		* @author Erwan Jolivet, Tomas Janak @date 2015 (EJ), 2016 (TJ)
		* \ingroup libhbm
		* \ref piper::hbm::FEModel
		*/
		class HBM_EXPORT FEModelVTK {

        public:	
            FEModelVTK();
			FEModelVTK(FEModel& femodel);
			~FEModelVTK();

            /// <summary>
            ///  Compute and save in the mesh, the cells quality of a VTK finite element model
            /// </summary>
            /// <param name="indexMetricFunctionUsed">The index of the metric function used to compute this quality</param>
            /// <param name="data">Data set of the mesh on which to compute the quality.</param>
            void static computeMeshQuality(int indexMetricFunctionUsed, vtkSmartPointer<vtkPointSet> data);
            //void exportQualityfile(std::string const& file) const;
            void clear();

            vtkSmartPointer<vtkUnstructuredGrid> getVTKMesh() {
                return m_mesh;
            };
			
			/// <summary>
			/// Gets the list of entity meshes. Each entity is denoted by its name.
			/// </summary>
			/// <returns>List of entity meshes. Each entity is denoted by its name.</returns>
			boost::container::map<std::string, vtkSmartPointer<vtkUnstructuredGrid>> *getVTKEntityMesh() {
				return &m_entitymesh;
			};

			/// <summary>
            /// Returns the mesh of a single entity of the current FEModel.
            /// </summary>
            /// <param name="name">The name of the entity.</param>
            /// <returns>The entity as a vtkUnstructuredGrid. Note that the "points" of this entity (that you can get through getPoints) are
            /// ALL the nodes of the mesh. To get indices of only the nodes this entity is made of, use "getEntityNodes".
            /// If there is no such entity present, returns NULL.</returns>
            vtkSmartPointer<vtkUnstructuredGrid> getEntity(std::string name);
            
            /// <summary>
            /// Gets the list of node IDs of nodes that a given entity is made of.
            /// </summary>
            /// <param name="name">The name of the entity.</param>
            /// <param name="entityNodes">List of node IDs the entity is made of, i.e. nodes that are used by the elements of this entity. These indices
            /// point to the array you can obtain by calling getPoints on your entity.</param>
            void getEntityNodesIDs(std::string name, hbm::VId &entityNodes);

			/// <summary>
			/// Converts the FEModel into a vtk representation.
			/// </summary>
			/// <param name="femodel">The femodel to convert.</param>
			void setMesh(FEModel& femodel);

			/// <summary>
			/// Converts each entity of the HumanBodyModel into a vtk representation and stores it. Unlike setMesh,
			/// this does not create the return value for getVTKMesh, only for the getVTKEntityMesh!
			/// </summary>
			/// <param name="entities">List of entities of the FE model.</param>
			/// <param name="fem">The femodel to convert.</param>
			/// <param name="resetNodes">If set to <c>false</c>, it will assume that nodes were already extracted
			/// before (using any of the set*** methods) and that these points should be used for this femodel so there is no need to extract them again.
			/// If set to true, nodes will be extracted.</param>
			void setMeshAsEntities(Metadata::EntityCont const& entities, FEModel& fem, bool resetNodes);


			/// <summary>
			/// Converts a single selected entity of one FEModel to a vtk representation.
            /// The ORIGINAL_CELL_IDS (macro defined in VtkSelectionTools.h) of each entity mesh cellData array
            /// contains the original indices of the full mesh cells for each cell of the entity mesh.
			/// </summary>
			/// <param name="entity">The entity to be convert.</param>
			/// <param name="m_fem">The model that has all the entities.</param>
			/// <param name="resetNodes">If set to <c>false</c>, it will assume that nodes were already extracted
			/// before (using any of the set*** methods) and that these points should be used for this femodel so there is no need to extract them again.
			/// If set to true, nodes will be extracted.</param>
			vtkSmartPointer<vtkUnstructuredGrid> addEntityMesh(Entity entity, FEModel& m_fem, bool resetNodes);
			
			/// <summary>
			/// Creates a vtk representation of all the nodes of the selected FE model and stores them in the m_points variable.
			/// </summary>
			/// <param name="femodel">The FE model from which to extract the nodes.</param>
			void setPoints(FEModel& femodel);

            void read(std::string const& filename);
            void write(std::string const& filename) const;
			
			/// <summary>
			/// Extracts 2D elements (triangles and quads) from this instance of the grid and stores
			/// them as a vtkPolyData, including connectivity and scalar attributes.
			/// This in essence converts this FEModelVTK to vtkPolyData, assuming there are some 2D elements in the grid.
			/// This does NOT create any new data and does NOT extract surface from 3D element-based model. Use generatePolyDataRep for that.
			/// </summary>
			/// <seealso cref="generatePolyDataRep" />
			/// <param name="rebuild">If true, the return object will be re-created even if it already exists.</param>
			/// <returns>
			/// vtkPolyData representation of the surface of this FEModelVTK -
			/// vertex position data is shared between the returned object and this FEModelVTK,
			/// so altering the returned object will alter this one as well. Do not dispose of the returned object, it will be disposed
			/// together with this FEModelVTK (make your own copy of the polydata if you want to dispose of the un.grid but keep the polydata).
			/// The return object is stored inside FEModelVTK and created only if it does not exist, so do not be afraid to call this method multiple times,
			/// the builiding process will happen only once (unless you specify rebuild = true).
			/// </returns>
			vtkSmartPointer<vtkPolyData> get2DElements(bool rebuild);
            
            /// <summary>
            /// Creates a mesh made of all entities that are marked as skin in the anatomyDB.
            /// Only 2D elements are used. Unlike the other entity meshes, this does NOT share the points with the m_mesh,
            /// instead it keeps it's own set of points that are only the points used in this mesh. The "nid" pointData array
            /// can still be used though to point to the original points of the FE getVTKMesh.
            /// The ORIG_CELL_ID array can be used to get element IDs in the full mesh, i.e. IDs of cells in the getVTKMesh() instance.
            /// setMeshAsEntities must be called before calling this in order for this to have any effect.
            /// </summary>
			/// <param name="rebuild">If true, the return object will be re-created even if it already exists.</param>
            /// <param name="entities">The list of entities to be used for anatomyDB querries.</param>
            /// <param name="fem">The FE model.</param>
            /// <returns>Skin mesh concatenated from all skin entities.</returns>
            vtkSmartPointer<vtkPolyData> getSkin(bool rebuild, Metadata::EntityCont const& entities, FEModel& fem);
			
			/// <summary>
			/// Returns a new instance of vtkPolydata containing only 2D elements beloging to the specified entity of the fem model.
			/// setMeshAsEntities must be called before this!
            /// The ORIGINAL_CELL_IDS (macro defined in VtkSelectionTools.h) cellData array contains the corresponding indices of the entity cells for each cell of the returned mesh.
			/// </summary>
            /// <param name="entityName">Name of the entity from which to extract the elements.</param>
			/// <returns>A new polydata. NULL if there is no entity with the specified name. Its points array is shared with this FEModelVTK!</returns>
            vtkSmartPointer<vtkPolyData> getEntity2DElements(std::string entityName);
			
			/// <summary>
			/// Converts ALL elements of this model into 2D cells (triangles and quads).
			/// All scalar arrays are converted in such a way that each new cell that belonged to a given element will have the same scalar value as that element.
			/// Esentially, the difference between using this and vtkDataSetSurfaceFilter is that this keeps ALL faces, not just boundary ones
			/// - even those that are shared by more elements. It duplicates those faces as well, i.e. if a given face is shared by two elements,
			/// it will be twice in the data set - but each can have different scalar values assigned if the two original elements had different scalar values.
			/// </summary>
			/// <seealso cref="get2DElements" />
			/// <param name="rebuild">If true, the return object will be re-created even if it already exists.</param>
			/// <returns>
			/// vtkPolyData representation of this FEModelVTK -
			/// vertex position data is shared between the returned object and this FEModelVTK,
			/// so altering the returned object will alter this one as well. Do not dispose of the returned object, it will be disposed
			/// together with this FEModelVTK (make your own copy of the polydata if you want to dispose of this object but keep the polydata).
			/// The return object is stored inside FEModelVTK and created only if it does not exist, so do not be afraid to call this method multiple times,
			/// the builiding process will happen only once (unless you specify rebuild = true).
			/// </returns>
			vtkPolyData *getPolyDataRep(bool rebuild);
            
            /// <summary>
            /// Returns the element IDs of all selected elements.
            /// This will combine selected cells of both the entity meshes and the full model mesh.
            /// </summary>
            /// <param name="chosenDimension">Only elements of the specified dimension will be appended (1 for lines, 2 for triangles, quads etc., 3 for tetra, hexa etc.).</param>
            /// <return>IDs of selected elements </return>
			/// <seealso cref="getSelectedElementsByEntities" />
            hbm::VId getSelectedElements(int chosenDimension) const;
            
            /// <summary>
            /// Returns the element IDs of all selected elements.
            /// This is done by entity, meaning the result is a map containing vectors of IDs for each entity.
            /// The key to the map is the name of the entity, or the string "undefinedEntity" for elements that don't belong to any entity (basically elements selected on the full mesh).
            /// </summary>
            /// <param name="chosenDimension">Only elements of the specified dimension will be appended (1 for lines, 2 for triangles, quads etc., 3 for tetra, hexa etc.).</param>
            /// <return>FE element IDs of selected elements mapped by the entity they belong to. Elements not belonging to any entity are stored under the name "undefined".</return>
            /// <seealso cref="getSelectedElements" />
            std::map<std::string, hbm::VId> getSelectedElementsByEntities(int chosenEleDimension) const;

            /// <summary>
            /// Returns the IDs of all selected nodes to the provided vector.
            /// </summary>
            /// <return>FE node IDs of only selected nodes.</param>
            hbm::VId getSelectedNodes() const;
			
			/// <summary>
			/// Copies node positions from this FEModelVTK to the specified FEModel.
			/// </summary>
			/// <param name="femodel">The model that you want to update with new coordinates.</param>
			void updateFEmodelNodes(FEModel* femodel);

			
			/// <summary>
			/// Creates nodes as piper::hbm::Node instances based on the vertices of this FEModelVTK
			/// and sets them to the specified model.
			/// </summary>
			/// <param name="femodel">The FE model to which the nodes will be assigned.</param>
			void generateFEmodelElements(FEModel& femodel);


			/// <summary>
			/// Creates elements as piper::hbm::Element instances based on the cells of this FEModelVTK
			/// and sets them to the specified model.
			/// </summary>
			/// <param name="femodel">The FE model to which the elements will be assigned.</param>
			void generateFEmodelNodes(FEModel& femodel);

            /// <summary>
            /// Builds unstructured grid(s) from selected elements in the main model. Each such grid will have
            /// several pointdata and celldata arrays (following names are names of the macros defined either in this file or vtkSelectionTools): 
            /// ORIGINAL_CELL_IDS and ORIGINAL_POINT_IDS with indices into this mesh.
            /// </summary>
            /// <param name="ignoreBones">If true, nodes that belong to bones will not be used even if selected.</param>
            /// <param name="entities">List of entities of the FE model.</param>
            /// <param name="fem">The femodel to convert.</param>
            /// <param name="exclude1D">If set to true, 1D elements will be excluded from the selection.</param>
            /// <param name="exclude2D">If set to true, 2D elements will be excluded from the selection.</param>
            /// <param name="exclude3D">If set to true, 3D elements will be excluded from the selection.</param>
            std::vector<vtkSmartPointer<vtkUnstructuredGrid>> extractSelectedParts(bool ignoreBones, 
                hbm::Metadata::EntityCont const& entities, FEModel& fem, bool exclude1D = false, bool exclude2D = false, bool exclude3D = false);

            /// <summary>
            /// Uses extractSelectedParts to store all connected components of elements selected from this mesh
            /// as separate vtkUnstructuredGrids (in xml). They will be named 0.vtk - (n-1).vtu, where n is number of connected 
            /// sets of selected elements.
            /// </summary>
            /// <param name="folderPath">A path to folder into which to store the meshes with the selected elements.</param>
            /// <param name="entities">List of entities of the FE model.</param>
            /// <param name="fem">The femodel to convert.</param>
            void writeSelectedElements(std::string folderPath, hbm::Metadata::EntityCont const& entities, FEModel& fem);

            /// <summary>
            /// Deselects elements with specified element ID. This is the IDs you would get from the FE model when you do setMeshDefNID.
            /// </summary>
            /// <param name="eid1D">IDs of 1D elements (lines, bars) to deselect.</param>
            /// <param name="eid2D">IDs of 2D elements (quads, tris) to deselect.</param>
            /// <param name="eid3D">IDs of 3D elements (hexa, tetra etc.) to deselect.</param>
            void deselectElementsByEid(const VId& eid1D, const VId& eid2D, const VId& eid3D);

            /// <summary>
            ///  Writes the quality values of the whole mesh in an excel file.
            /// </summary>
            /// <param name="filename">Path to the file we want to create with this function</param>
            /// <param name="indexMetricUsed">The index of the metric function used to compute this quality</param>
            void writeEntitiesQualityIntoFile(std::string const& filename, int indexMetricUsed);


            /// <summary>
            /// Gets all landmarks.
            /// </summary>
            /// <returns>A list of all landmark mapped by the landmark's name. Landmark is here represented as a list of node indices that the landmark is made of.</returns>
            boost::container::map<std::string, VId> *getAllLandmarkPoints() {
                return &m_landmarkPoints;
            };

            /// <summary>
            /// Gets the landmark mesh. This is a mesh with no cells, only points. Each point is a position of one landmark. 
            /// Use getLandmarkNameByPosition to get the name of a landmark with a given point index, or getLandmarkIndexByName to get the point index by name.
            /// </summary>
            /// <returns>Mesh with points representing landmark positions.</returns>
            vtkSmartPointer<vtkPolyData> getLandmarkMesh() {
                return m_landmarksMesh;
            };

            /// <summary>
            /// For a given point of the FE model, returns each landmark that uses this point in its definition.
            /// </summary>
            /// <param name="pointID">The point identifier of a mesh point. 
            /// This is a point in the main mesh - not a point tha represents a landmark mesh! If that is what you want, use getLandmarkNameByPosition.</param>
            /// <returns>Name of all landmarks this point belongs to or empty container if it is not associated with any landmark.</returns>
            boost::container::vector<std::string> getLandmarkAssociatedWithPoint(int pointID);

            /// <summary>
            /// Gives a landmark that is at the position described by the point with pointID in the landmarkMesh (obtainable by getLandmarkMesh).
            /// </summary>
            /// <param name="pointID">The point identifier that points into the landmarkMesh.</param>
            /// <returns>The landmark belonging to the point. Null if there is no such landmark.</returns>
            hbm::Landmark const *getLandmarkFromLandmarkMesh(int pointID);

            /// <summary>
            /// Gets the index into the landmarkMesh of a landmark with the specified name.
            /// </summary>
            /// <param name="landmarkName">Name of the landmark.</param>
            /// <returns>Index of a point in the landmarkMesh (obtainable through getLandmarkMesh) that represents a landmark with the given name. -1 if there is no such landmark.</returns>
            int getLandmarkIndexByName(std::string landmarkName);

            /// <summary>
            /// Returns the points that define the specified landmark if it exists in the model.
            /// </summary>
            /// <param name="landmarkName">Name of the landmark to retrieve.</param>
            /// <returns>The landmark as a list of node indices that it is made of. NULL if there is no landmark with the specified name.</returns>
            VId *getLandmarkPoints(std::string landmarkName);

            /// <summary>
            /// Creates a vtk representation of a FEModel's landmarks, obtainable by <see cref="getLandmarkMesh"/>.
            /// </summary>
            /// <param name="landmarks">Landmarks to represent.</param>
            /// <param name="fem">The FEModel corresponding to the landmarks container.</param>
            /// <param name="resetNodes">If set to <c>false</c>, it will assume that nodes were already extracted
            /// before (using any of the set*** methods) and that these points should be used for this femodel so there is no need to extract them again.
            /// If set to true, nodes will be extracted.</param>
            void setModelLandmarks(Metadata::LandmarkCont const &landmarks, FEModel& fem, bool resetNodes);
            
            /// <summary>
            /// Adds the landmark to the landmark mesh and updates all landmark-related structures. 
            /// !!! setModelLandmarks MUST BE CALLED AT LEAST ONCE BEFORE ADDING ANY LANDMARK !!!
            /// </summary>
            /// <param name="landmark">The landmark.</param>
            /// <param name="m_fem">The m_fem.</param>
            void addLandmark(Landmark const *landmark, FEModel& m_fem);

            /// <summary>
            /// Mark the group of points defining the specified landmark as "active". This is used mainly by visualization - only active landmarks are visualized.
            /// </summary>
            /// <param name="name">The name of the landmark.</param>
            void activateLandmarkPoints(std::string name);

            /// <summary>
            /// Mark the group of points defining the specified landmark as "inactive". This is used mainly by visualization - only active landmarks are visualized.
            /// Note - deactivating a landmark will also de-select it if it is selected.
            /// </summary>
            /// <param name="name">The name of the landmark.</param>
            void deactivateLandmarkPoints(std::string name);

            /// <summary>
            /// Mark the specified landmark as "active". This is used mainly by visualization - only active landmarks are visualized.
            /// </summary>
            /// <param name="name">The name of the landmark.</param>
            void activateLandmarkPositions(std::string name);

            /// <summary>
            /// Mark the specified landmark as "inactive". This is used mainly by visualization - only active landmarks are visualized.
            /// Note - deactivating a landmark will also de-select it if it is selected.
            /// </summary>
            /// <param name="name">The name of the landmark.</param>
            void deactivateMeshLandmarkPositions(std::string name);


			/// <summary>
			/// Gets the list of genericMetadata meshes. Each genericMetadata is denoted by its name.
			/// </summary>
			/// <returns>List of genericMetadata meshes. Each genericMetadata is denoted by its name.</returns>
			boost::container::map<std::string, vtkSmartPointer<vtkUnstructuredGrid>> *getVTKGenericMetadataMesh() {
				return &m_genericmetadatamesh;
			};

			/// <summary>
			/// Returns the mesh of a single genericMetadata of the current FEModel.
			/// </summary>
			/// <param name="name">The name of the genericMetadata.</param>
			/// <returns>The genericMetadata as a vtkUnstructuredGrid. Note that the "points" of this genericMetadata (that you can get through getPoints) are
			/// ALL the nodes of the mesh. To get indices of only the nodes this genericMetadata is made of, use "getGenericMetadataNodes".
			/// If there is no such genericMetadata present, returns nullptr.</returns>
			vtkSmartPointer<vtkUnstructuredGrid> getGenericMetadata(std::string name);

			/// <summary>
			/// Gets the list of node IDs of nodes that a given genericMetadata is made of.
			/// </summary>
			/// <param name="name">The name of the genericMetadata.</param>
			/// <param name="genericMetadataNodes">List of node IDs the genericMetadata is made of, i.e. nodes that are used by the elements of this genericMetadata. These indices
			/// point to the array you can obtain by calling getPoints on your genericMetadata.</param>
			void getGenericMetadataNodesIDs(std::string name, hbm::VId &genericMetadataNodes);

			/// <summary>
			/// Converts each genericMetadata of the HumanBodyModel into a vtk representation and stores it. Unlike setMesh,
			/// this does not create the return value for getVTKMesh, only for the getVTKGenericMetadataMesh!
			/// </summary>
			/// <param name="genericMetadatas">List of genericMetadatas of the FE model.</param>
			/// <param name="fem">The femodel to convert.</param>
			/// <param name="resetNodes">If set to <c>false</c>, it will assume that nodes were already extracted
			/// before (using any of the set*** methods) and that these points should be used for this femodel so there is no need to extract them again.
			/// If set to true, nodes will be extracted.</param>
			void setMeshAsGenericMetadatas(Metadata::GenericMetadataCont const& genericMetadatas, FEModel& fem, bool resetNodes);


			/// <summary>
			/// Converts a single selected genericMetadata of one FEModel to a vtk representation.
            /// The mesh is then retrieavable via getGenericMetadata(genericMetadata.name()).
			/// </summary>
			/// <param name="genericMetadata">The genericMetadata to be converted.</param>
			/// <param name="m_fem">The model that has all the genericMetadatas.</param>
			/// <param name="resetNodes">If set to <c>false</c>, it will assume that nodes were already extracted
			/// before (using any of the set*** methods) and that these points should be used for this femodel so there is no need to extract them again.
			/// If set to true, nodes will be extracted.</param>
			void addGenericMetadataMesh(GenericMetadata genericMetadata, FEModel& m_fem, bool resetNodes);
			
        protected:
            vtkSmartPointer<vtkUnstructuredGrid> m_mesh;
			boost::container::map<std::string, vtkSmartPointer<vtkUnstructuredGrid>> m_entitymesh;
			boost::container::map<std::string, vtkSmartPointer<vtkUnstructuredGrid>> m_enventitymesh;

            boost::container::map<std::string, VId> m_landmarkPoints; // for each landmark, stores the indices of the points this landmark is made of
            vtkSmartPointer<vtkPolyData> m_landmarksMesh; // the points array of this mesh contains the positions of individual landmarks. The indexing has to be kept synchronized with indexing of m_landmarkMap!
            boost::container::vector<hbm::Landmark const*> m_landmarkMap; // maps pointers to hbm::landmarks by their index of the point in the landmarkMesh. The indexing has to be kept synchronized with indexing of points of m_landmarkMesh!
            boost::container::map<std::string, int> m_landmarkIndexMap; // maps indices of landmarks stored as points the m_landmarkMesh by the name of the landmark

			vtkSmartPointer<vtkPolyData> m_2DElementMesh; // only 2D elements of the mesh
			vtkSmartPointer<vtkPolyData> m_mesh2Drep; // all elements converted to 2D elements
            vtkSmartPointer<vtkPolyData> m_skin; // mesh made as a concatenation of all entites that are marked as skin in the anatomyDB

            // maps the original FE id of elements to cell ids of the m_mesh cells
            // we have to use actual maps instead of CellData scalar arrays because the FE IDs can be various, maxID can be much higher than number of IDs etc.
            boost::container::map<Id, vtkIdType> m_mapFEIdToVtkId1D;
            boost::container::map<Id, vtkIdType> m_mapFEIdToVtkId2D;
            boost::container::map<Id, vtkIdType> m_mapFEIdToVtkId3D;

			/// <summary>
			/// Converts a single selected entity of one FEModel to a vtk representation. 
			/// The only difference between this and addEnitityMesh is that it already assumes that m_fem->setMeshDef_INDEX() has already been called.
			/// </summary>
			/// <param name="entity">The entity to be convert.</param>
			/// <param name="m_fem">The model that has all the entities.</param>
			/// <param name="resetNodes">If set to <c>false</c>, it will assume that nodes were already extracted
			/// before (using any of the set*** methods) and that these points should be used for this femodel so there is no need to extract them again.
			/// If set to true, nodes will be extracted.</param>
			void addEntityMeshInternal(Entity entity, FEModel& m_fem, bool resetNodes);

            /// <summary>
            /// Mark the specified landmark. This is used mainly by visualization - only active landmarks are visualized.
            /// </summary>
            /// <param name="name">The name of the landmark.</param>
            /// <param name="activate">True to mark the landmark as active, false to mark it as inactive.</param>
            void activateLandmarkPoints(std::string name, bool activate);

            /// <summary>
            /// Mark the group of points defining the specified landmark. This is used mainly by visualization - only active landmarks are visualized.
            /// </summary>
            /// <param name="name">The name of the landmark.</param>
            /// <param name="activate">True to mark the landmark as active, false to mark it as inactive.</param>
            void activateLandmarkPositions(std::string name, bool activate);

			boost::container::map<std::string, vtkSmartPointer<vtkUnstructuredGrid>> m_genericmetadatamesh;

			/// <summary>
			/// Converts a single selected genericMetadata of one FEModel to a vtk representation. 
			/// The only difference between this and addGenericMetadataMesh is that it already assumes that m_fem->setMeshDef_INDEX() has already been called.
			/// </summary>
			/// <param name="genericMetadata">The genericMetadata to be convert.</param>
			/// <param name="m_fem">The model that has all the genericMetadatas.</param>
			/// <param name="resetNodes">If set to <c>false</c>, it will assume that nodes were already extracted
			/// before (using any of the set*** methods) and that these points should be used for this femodel so there is no need to extract them again.
			/// If set to true, nodes will be extracted.</param>
			void addGenericMetadataMeshInternal(GenericMetadata genericMetadata, FEModel& m_fem, bool resetNodes);
        };

    }
}

#endif // PIPER_HBM_VTKFEMODEL_H
